﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
	<title></title>
	<style type="text/css">
		.toBeCopied {
			background: #bde0c5!important;
		}

		.toPasteFrom {
			background: #e0f6ff!important;
		}
	</style>
</head>
<body>
	<form id="form1" runat="server">
		<asp:ScriptManager ID="RadScriptManager1" runat="server">
			<Scripts>
				<asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.Core.js" />
				<asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQuery.js" />
				<asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQueryInclude.js" />
			</Scripts>
		</asp:ScriptManager>

		<telerik:RadCodeBlock ID="RadCodeBlock1" runat="server">
		    <script type="text/javascript">
		    	var demo = (function () {
		    		var copiedCell = null;
		    		var copiedCellValue;
		    		var copiedItem = null;
		    		var targetCell;
		    		var targetCellIndex;
		    		var targetDataItem;
		    		var batchManager;
		    		var applyHoverStyles;

		    		window.pageLoad = function () {
		    			batchManager = $find("<%=RadGrid1.ClientID%>").get_batchEditingManager();
		            }

					// creates a string representation of the copied row, which will be displayed as a tooltip for the "Paste Row" item
		    		function createTooltip(row) {
		        		var content = [];
		        		for (var i = 0; i < row.cells.length; i++) {
		        			content.push(batchManager.getCellValue(row.cells[i]));
		        		}

		        		return content.join(", ");
		        	}

					// clears all custom styles added to cells/rows
		        	function clearStyles() {
		        		if (copiedItem != null) {
		        			copiedItem.get_element().cells[targetCellIndex].className
								= copiedItem.get_element().cells[targetCellIndex].className.replace("toPasteFrom", "");
		        			copiedItem.get_element().className = copiedItem.get_element().className.replace("toPasteFrom", "");
		        		}

		        		targetDataItem.get_element().className = targetDataItem.get_element().className.replace("toBeCopied", "");
		        		targetCell.className = targetCell.className.replace("toBeCopied", "");
		        	}

		        	function getItemValue(item, index) {
		        		return batchManager.getCellValue(item.get_element().cells[index]);
		        	}

		        	return {
		        		rowContextMenu: function (sender, args) {
		        			applyHoverStyles = true;
		        			var contextMenu = $find("<%=RadContextMenu1.ClientID%>");
			            	contextMenu.show(args.get_domEvent());
			            	targetCell = Telerik.Web.UI.Grid.GetFirstParentByTagName(args.get_domEvent().target, "TD");
			            	targetCellIndex = targetCell.cellIndex;
			            	targetDataItem = args.get_gridDataItem();
			            },

		        		itemClicked: function (sender, args) {
		        			var clickedValue = args.get_item().get_value();
		        			applyHoverStyles = false;
			            	if (clickedValue == "PasteCell") {
			            		batchManager.changeCellValue(targetCell, getItemValue(copiedItem, targetCellIndex));
			            	} else if (clickedValue == "CopyRow") {
			            		var items = sender.get_items();
			            		copiedItem = targetDataItem;
			            		items.getItem(1).set_enabled(true);
			            		items.getItem(1).get_element().setAttribute("title", getItemValue(copiedItem, targetCellIndex));
			            		items.getItem(2).set_enabled(true);
			            		items.getItem(2).get_element().setAttribute("title", createTooltip(copiedItem.get_element()));
			            	} else {
			            		var copiedRow = copiedItem.get_element();
			            		var currentRow = targetDataItem.get_element();
			            		for (var i = 0; i < copiedRow.cells.length; i++) {
			            			batchManager.changeCellValue(currentRow.cells[i], batchManager.getCellValue(copiedRow.cells[i]));
			            		}
			            	}
			            	
			            	clearStyles();
			            },

						//used for changing the style for the target cell
		        		mouseOver: function (sender, args) {
		        			if (applyHoverStyles) {
		        				var hoverValue = args.get_item().get_value();
		        				if (hoverValue == "PasteCell") {
		        					targetCell.className += " toBeCopied";
		        					copiedItem.get_element().cells[targetCellIndex].className += " toPasteFrom";
		        				} else if (hoverValue == "CopyRow") {
		        					targetDataItem.get_element().className += " toBeCopied";
		        				} else if (hoverValue == "PasteRow") {
		        					copiedItem.get_element().className += " toPasteFrom";
		        					targetDataItem.get_element().className += " toBeCopied";
		        				}
		        			}
			            },

			            mouseOut: function (sender, args) {
			            	clearStyles();
			            },

			            hidden: function () {
			            	clearStyles();
			            }
			        }
		        })();
		    </script>
		</telerik:RadCodeBlock>
		
		<telerik:RadContextMenu runat="server" ID="RadContextMenu1" OnClientMouseOver="demo.mouseOver" OnClientHidden="demo.hidden"
			 OnClientMouseOut="demo.mouseOut" OnClientItemClicked="demo.itemClicked">
			<Items>
				<telerik:RadMenuItem Text="Copy" Value="CopyRow"></telerik:RadMenuItem>
				<telerik:RadMenuItem Text="Paste Cell" Value="PasteCell" Enabled="false"></telerik:RadMenuItem>
				<telerik:RadMenuItem Text="Paste Row" Value="PasteRow" Enabled="false"></telerik:RadMenuItem>
			</Items>
		</telerik:RadContextMenu>

		<telerik:RadGrid runat="server" ID="RadGrid1" OnNeedDataSource="RadGrid1_NeedDataSource" Width="500px">
			<MasterTableView EditMode="Batch" CommandItemDisplay="Top">
				<BatchEditingSettings EditType="Row" />
			</MasterTableView>
			<ClientSettings>
				<ClientEvents OnRowContextMenu="demo.rowContextMenu" />
			</ClientSettings>
		</telerik:RadGrid>
	</form>
</body>
</html>
